// pe.h				LiuTaoTao 1998

typedef char               *PSTR;
typedef unsigned long       DWORD;
typedef unsigned char       BYTE;
typedef unsigned short      WORD;

#define pd(a)	*(DWORD *)(a)
#define pw(a)	*(WORD *)(a)
/*
     A VA is a virtual address that is already biased by the Image
     Base found in the PE Header.  A RVA is a virtual address that is
     relative to the Image Base.
*/
typedef struct {
    DWORD Signature;                //00    'PE'

//    IMAGE_FILE_HEADER FileHeader;
    WORD    Machine;                //04
    WORD    NumberOfSections;       //06
    DWORD   TimeDateStamp;          //08
    DWORD   PointerToSymbolTable;   //0c
    DWORD   NumberOfSymbols;        //10
    WORD    SizeOfOptionalHeader;   //14
    WORD    Characteristics;        //16

//    IMAGE_OPTIONAL_HEADER OptionalHeader;
    WORD    Magic;                    //+18
    BYTE    MajorLinkerVersion;       //+1a
    BYTE    MinorLinkerVersion;
    DWORD   SizeOfCode;               //+1c
    DWORD   SizeOfInitializedData;    //+20
    DWORD   SizeOfUninitializedData;
    DWORD   EntryPoint_RVA;
    DWORD   BaseOfCode;               //+2c
    DWORD   BaseOfData;               //+30
    DWORD   ImageBase;                //+34
    DWORD   SectionAlignment;
    DWORD   FileAlignment;
    WORD    MajorOperatingSystemVersion; //+40
    WORD    MinorOperatingSystemVersion;
    WORD    MajorImageVersion;
    WORD    MinorImageVersion;
    WORD    MajorSubsystemVersion;       //+48
    WORD    MinorSubsystemVersion;
    DWORD   Win32VersionValue;           //+4c
    DWORD   SizeOfImage;                 //+50
    DWORD   SizeOfHeaders;
    DWORD   CheckSum;                    //+58
    WORD    Subsystem;                   //+5c
    WORD    DllCharacteristics;
    DWORD   SizeOfStackReserve;          //+60
    DWORD   SizeOfStackCommit;
    DWORD   SizeOfHeapReserve;
    DWORD   SizeOfHeapCommit;
    DWORD   LoaderFlags;                 //+70
    DWORD   NumberOfRvaAndSizes;         //+74

//    IMAGE_DATA_DIRECTORY DataDirectory[IMAGE_NUMBEROF_DIRECTORY_ENTRIES];
    DWORD   EXPORT_Table_RVA;       //+78
    DWORD   EXPORT_Size;                 //+7c

    DWORD   IMPORT_Table_RVA;       //+80
    DWORD   IMPORT_Size;                 //+84

    DWORD   RESORC_Table_RVA;       //+88
    DWORD   RESORC_Size;                 //+8c

    DWORD   EXCEPT_Table_RVA;       //+90
    DWORD   EXCEPT_Size;                 //+94

    DWORD   SECURT_Table_RVA;       //+98
    DWORD   SECURT_Size;                 //+9c

} PE;

//
// Section header format.
//


typedef struct  {		//size = 40
    BYTE    Name[8];	//+0
    DWORD   VirtualSize;			//+8
    DWORD   RVA;					//+c
    DWORD   PhysicalSize;					//+10
    DWORD   PhysicalOffset;				//+14
    DWORD   PointerToRelocations;			//+18
    DWORD   PointerToLinenumbers;			//+1c
    WORD    NumberOfRelocations;			//+20
    WORD    NumberOfLinenumbers;			//+22
    DWORD   Object_Flags;				//+24
} Object_Table, *PObject_Table;

